package com.hfkj.dao;

import com.hfkj.entity.BsMer;
import com.hfkj.entity.BsMerExample.Criteria;
import com.hfkj.entity.BsMerExample.Criterion;
import com.hfkj.entity.BsMerExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMerSqlProvider {

    public String countByExample(BsMerExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_mer");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMerExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_mer");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMer record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_mer");
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerLogo() != null) {
            sql.VALUES("mer_logo", "#{merLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorName() != null) {
            sql.VALUES("director_name", "#{directorName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorTel() != null) {
            sql.VALUES("director_tel", "#{directorTel,jdbcType=VARCHAR}");
        }
        
        if (record.getCustomerServiceTel() != null) {
            sql.VALUES("customer_service_tel", "#{customerServiceTel,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.VALUES("address", "#{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMerExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_no");
        sql.SELECT("mer_logo");
        sql.SELECT("mer_name");
        sql.SELECT("director_name");
        sql.SELECT("director_tel");
        sql.SELECT("customer_service_tel");
        sql.SELECT("address");
        sql.SELECT("`status`");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_mer");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMer record = (BsMer) parameter.get("record");
        BsMerExample example = (BsMerExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_mer");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerLogo() != null) {
            sql.SET("mer_logo = #{record.merLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorName() != null) {
            sql.SET("director_name = #{record.directorName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorTel() != null) {
            sql.SET("director_tel = #{record.directorTel,jdbcType=VARCHAR}");
        }
        
        if (record.getCustomerServiceTel() != null) {
            sql.SET("customer_service_tel = #{record.customerServiceTel,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("mer_logo = #{record.merLogo,jdbcType=VARCHAR}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("director_name = #{record.directorName,jdbcType=VARCHAR}");
        sql.SET("director_tel = #{record.directorTel,jdbcType=VARCHAR}");
        sql.SET("customer_service_tel = #{record.customerServiceTel,jdbcType=VARCHAR}");
        sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMerExample example = (BsMerExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMer record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer");
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerLogo() != null) {
            sql.SET("mer_logo = #{merLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorName() != null) {
            sql.SET("director_name = #{directorName,jdbcType=VARCHAR}");
        }
        
        if (record.getDirectorTel() != null) {
            sql.SET("director_tel = #{directorTel,jdbcType=VARCHAR}");
        }
        
        if (record.getCustomerServiceTel() != null) {
            sql.SET("customer_service_tel = #{customerServiceTel,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMerExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}